%define thunderbird_package mozilla-thunderbird

%define name    mozilla-thunderbird-l10n
%define oname   mozilla-thunderbird
%define version 2.0.0.17
%define release %mkrel 1
%define thunderbird_epoch 0
%define thunderbird_version %{version}

%if %mdkversion <= 200700
%define up_ca_name      mozilla-thunderbird
%else
%define up_ca_name      thunderbird
%endif
%define lib_name        %{up_ca_name}-%version
%define mozillalibdir   %_libdir/%lib_name

%define xpidir http://ftp.mozilla.org/pub/mozilla.org/thunderbird/releases/%{thunderbird_version}/linux-i686/xpi/

# Supported l10n language lists
%define langlist	af be bg ca cs da de el en_GB es_AR es_ES et_EE eu fi fr gu_IN he hu it ja ko lt mk nb_NO nl nn_NO pa_IN pl pt_PT pt_BR ru sk sl sv_SE tr uk zh_CN zh_TW

# Disabled l10n languages, for any reason
%define disabled_langlist	%{nil}

# Disabled myspell dicts, for any reason
%define disabled_dict_langlist	ar be br_FR es_AR eu fi fy gu_IN he ja ko mk pa_IN tr zh_CN zh_TW

%define use_dict 1
%if %mdkversion == 200600
# CS4 doesn't have myspell, but has thunderbird.
%define use_dict 0
%endif
%if %mdkversion >= 200810
# We moved to pointing mozilladir/dictionaries -> /usr/share/dict/mozilla
%define use_dict 0
%endif

# Language descriptions
%define language_af af
%define langname_af Afrikaans
%define language_ar ar
%define langname_ar Arabic
%define language_be be
%define langname_be Belarusian
%define language_bg bg
%define langname_bg Bulgarian
%define language_br_FR br-FR
%define langname_br_FR Breton
%define language_ca ca
%define langname_ca Catalan
%define language_cs cs
%define langname_cs Czech
%define language_da da
%define langname_da Dansk
%define language_de de
%define langname_de German
%define language_el el
%define langname_el Greek
%define language_en_GB en-GB
%define langname_en_GB British English
%define language_es_AR es-AR
%define langname_es_AR Spanish (Argentina)
%define language_es_ES es-ES
%define langname_es_ES Spanish
%define language_et_EE et-EE
%define langname_et_EE Estonian
%define language_eu eu
%define langname_eu Basque
%define language_fi fi
%define langname_fi Finnish
%define language_fr fr
%define langname_fr French
%define language_fy fy-NL
%define langname_fy Frisian
%define language_ga ga-IE
%define langname_ga Irish
%define language_gu_IN gu-IN
%define langname_gu_IN Gujarati
%define language_he he
%define langname_he Hebrew
%define language_hu hu
%define langname_hu Hungarian
%define language_it it
%define langname_it Italian
%define language_ja ja
%define langname_ja Japanese
%define language_ko ko
%define langname_ko Korean
%define language_lt lt
%define langname_lt Lithuanian
%define language_mk mk
%define langname_mk Macedonian
%define language_nb_NO nb-NO
%define langname_nb_NO Norwegian Bokmaal
%define language_nn_NO nn-NO
%define langname_nn_NO Norwegian Nynorsk
%define language_nl nl
%define langname_nl Dutch
%define language_pa_IN pa-IN
%define langname_pa_IN Punjabi (gurmukhi)
%define language_pl pl
%define langname_pl Polish
%define language_pt_BR pt-BR
%define langname_pt_BR Brazilian portuguese
%define language_pt_PT pt-PT
%define langname_pt_PT Portuguese
%define language_ro ro
%define langname_ro Romanian
%define language_ru ru
%define langname_ru Russian
%define language_sk sk
%define langname_sk Slovak
%define language_sl sl
%define langname_sl Slovenian
%define language_sv_SE sv-SE
%define langname_sv_SE Swedish
%define language_tr tr
%define langname_tr Turkish
%define language_uk uk
%define langname_uk Ukrainian
%define language_zh_CN zh-CN
%define langname_zh_CN Simplified Chinese
%define language_zh_TW zh-TW
%define langname_zh_TW Traditional Chinese

# --- Danger line ---

# Defaults (all languages enabled by default)
# l10n
%{expand:%(for lang in %langlist; do echo "%%define with_$lang 1"; done)}
%{expand:%(for lang in %disabled_langlist; do echo "%%define with_$lang 0"; done)}
# dicts
%{expand:%(for lang in %langlist; do echo "%%define with_dict_$lang %{use_dict}"; done)}
%{expand:%(for lang in %disabled_dict_langlist; do echo "%%define with_dict_$lang 0"; done)}

# Locales
%{expand:%(for lang in %langlist; do echo "%%define locale_$lang `echo $lang | cut -d _ -f 1` "; done)}

%if %use_dict
# myspell dicts, allows setting preferences between several providers.
%{expand:%(for lang in %langlist; do echo "%%define myspell_$lang myspell-$lang"; done)}
%define myspell_de myspell-de_DE
%define myspell_fr myspell-fr_FR
%endif

# Macro for easy adding i18n sources
# auto-increment as called.
%define src 1

%define l10nsrc() Source%src: %{xpidir}/%{1}.xpi\
%define src2 %(echo $((%src+1)))\
%define src %{src2}

Summary: Localizations for Thunderbird (virtual package)
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: Networking/WWW
Url: http://www.mozilla.org/
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: libxml2-utils
# Language package template
Source0: %{name}-template.spec
# l10n sources
%{expand:%(\
	for lang in %langlist; do\
		echo "%%{expand:%%l10nsrc %%{language_$lang}}";\
	done\
	)
}
%if %use_dict
%{expand:%(\
	disabled="%{disabled_dict_langlist}";\
	for lang in %langlist; do\
		echo "$disabled" | grep -q "\<$lang\>" || \
			echo "BuildRequires: %%{myspell_$lang}";\
	done\
	)
}
%endif

%description
Localizations for Thunderbird

# Expand all languages packages.
%{expand:%(\
	for lang in %langlist; do\
		echo "%%{expand:%%(sed "s!__LANG__!$lang!g" %{_sourcedir}/%{name}-template.spec 2> /dev/null)}";\
	done\
	)
}

%prep
%setup -q -c -T

# Convert rpm macros to bash variables
%{expand:%(for lang in %langlist; do echo "language_$lang=%%{language_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "locale_$lang=%%{locale_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "with_$lang=%%{with_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "dict_$lang=%%{with_dict_$lang}"; done)}

# Unpack all languages
for lang in %langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	language="language_$lang"
	language=${!language}

	locale="locale_$lang"
	locale=${!locale}

	# l10n
	mkdir ${language}
	cd ${language}
	unzip %{_sourcedir}/${language}.xpi
	cd ..

	# dict
	dict="dict_$lang"
	dict=${!dict}
	[ $dict -eq 0 ] && continue

	mkdir -p ${language}-dict/dictionaries
	cd ${language}-dict
	if [ -e %{_datadir}/dict/ooo/$lang.aff ]; then
		ln -s %{_datadir}/dict/ooo/$lang.aff ./dictionaries/$language.aff
		ln -s %{_datadir}/dict/ooo/$lang.dic ./dictionaries/$language.dic
	elif [ -e %{_datadir}/dict/ooo/$locale.aff ]; then
		ln -s %{_datadir}/dict/ooo/$locale.aff ./dictionaries/$language.aff
		ln -s %{_datadir}/dict/ooo/$locale.dic ./dictionaries/$language.dic
	else
		ln -s %{_datadir}/dict/ooo/${locale}_*.aff ./dictionaries/$language.aff
		ln -s %{_datadir}/dict/ooo/${locale}_*.dic ./dictionaries/$language.dic
	fi
	cd ..
done

# Patches

%build
# All install.rdf files must validate
xmllint --noout */install.rdf

%install
rm -rf %buildroot

# Convert rpm macros to bash variables
%{expand:%(for lang in %langlist; do echo "language_$lang=%%{language_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "with_$lang=%%{with_$lang}"; done)}
%{expand:%(for lang in %langlist; do echo "dict_$lang=%%{with_dict_$lang}"; done)}

# Create dicts dir
%if %use_dict
mkdir -p %buildroot%{mozillalibdir}/dictionaries
%endif

# Install all languages
for lang in %langlist; do
	with="with_$lang"
	with=${!with}
	[ $with -eq 0 ] && continue

	language="language_$lang"
	language=${!language}

	# l10n
	cd $language
	mkdir -p %buildroot%{mozillalibdir}/extensions/langpack-${language}@thunderbird.mozilla.org/
	cp -f -r * %buildroot%{mozillalibdir}/extensions/langpack-${language}@thunderbird.mozilla.org/
	cd ..

	# Dicts
	dict="dict_$lang"
	dict=${!dict}
	[ $dict -eq 0 ] && continue

	cp -af $language-dict/dictionaries/*.{aff,dic} \
		%buildroot%{mozillalibdir}/dictionaries/
done

%clean
rm -rf %buildroot


%changelog
* Mon Sep 29 2008 Funda Wang <fundawang@mandriva.org> 2.0.0.17-1mdv2009.0
+ Revision: 289437
- New version 2.0.0.17

* Thu Jul 24 2008 Tiago Salem <salem@mandriva.com.br> 2.0.0.16-1mdv2009.0
+ Revision: 247332
- update to 2.0.0.16

* Fri May 02 2008 Funda Wang <fundawang@mandriva.org> 2.0.0.14-1mdv2009.0
+ Revision: 200206
- New version 2.0.0.14

* Wed Feb 27 2008 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.12-1mdv2008.1
+ Revision: 175852
- Work-around for rpmlint
- New upstream: 2.0.0.12
- Disable dict links for mdkversion >= 200810. We are going to symlink entire
  mozilladir/dictionaries instead. Closes: #21370

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Dec 02 2007 Funda Wang <fundawang@mandriva.org> 2.0.0.9-1mdv2008.1
+ Revision: 114426
- New version 2.0.0.9

* Fri Aug 24 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.6-2mdv2008.0
+ Revision: 71055
- Merged with FF specs.

* Thu Aug 02 2007 Funda Wang <fundawang@mandriva.org> 2.0.0.6-1mdv2008.0
+ Revision: 58009
- New version 2.0.0.6

* Fri Jul 20 2007 Funda Wang <fundawang@mandriva.org> 2.0.0.5-1mdv2008.0
+ Revision: 53805
- New version

* Fri Jun 15 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.4-1mdv2008.0
+ Revision: 39938
- Synced with thunderbird version (2.0.0.4).
- Updated all langpacks except for et-EE, gu-IN and he which weren't available.
- Added Estonian support. Thanks to Sander for it.

* Mon May 07 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.0-3mdv2008.0
+ Revision: 24096
- Fix pt langname: it must be called pt_PT, as this is what is inside it.

* Tue Apr 24 2007 Funda Wang <fundawang@mandriva.org> 2.0.0.0-2mdv2008.0
+ Revision: 17836
- add more languages.

* Fri Apr 20 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0.0.0-1mdv2008.0
+ Revision: 15997
- Synced version with thunderbird's one.
- Updated lang packs.


* Tue Mar 20 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0b2-2mdv2007.1
+ Revision: 146986
- Added Dutch spell check dictionary based on Reinout van Schouwen changes. Closes: #29652

* Wed Feb 07 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 2.0b2-1mdv2007.1
+ Revision: 117079
- Support for thunderbird 2.0b2
- Updated all xpi included.
- Removed languages that don't have support yet.
- Added dicitionaries.

* Tue Jan 09 2007 Marcelo Ricardo Leitner <mrl@mandriva.com> 1.5.0.9-1mdv2007.1
+ Revision: 106425
- Synced with new upstream.

* Thu Nov 09 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.8-1mdv2007.1
+ Revision: 79550
-Update langpack to 1.5.0.8
-Remove patch1 (no longer needed)
-Add Gujarati langpack

* Sat Sep 16 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.7-1mdv2007.0
+ Revision: 61637
- Release 1.5.0.7
  Add new langpacks

* Thu Sep 07 2006 Frederic Crozat <fcrozat@mandriva.com> 1.5.0.5-2mdv2007.0
+ Revision: 60328
-Major cleanup
-Check if install.rdf files are valid

  + Nicolas Lécureuil <neoclust@mandriva.org>
    - Add macro for corpo3
    - import mozilla-thunderbird-l10n-1.5.0.5-2mdv2007.0

